varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

uniform int colorMode;
uniform lowp float offset;

highp float shiftedX;
highp float shiftedY;
highp float shiftedX1;
highp float shiftedY1;
highp float shiftedX2;
highp float shiftedY2;

highp float fixShiftedValue(highp float shfitedValue) {
    // Cycle
    if (shfitedValue > 1.0) {
        return shfitedValue - 1.0;
    }
    else if (shfitedValue < 0.0) {
        return shfitedValue + 1.0;
    }

    return shfitedValue;
}

highp float truncSine(highp float x) {
    // Half sine wave
    highp float height = 0.5;
    highp float sineWidth = 0.5;
    const highp float pi = 3.1415;

    if(x < 0.0 || x > sineWidth)
    return 0.0;
    else
    return sin(x * pi/sineWidth) * height;
}

highp float rdWave(highp float x, highp float t) {
    //return truncSine(x - t) * triangle(x);
    // truncated position
    highp float truncSineX = fract(x+offset*5.0+t);
    lowp float waveDenity = offset;
    return truncSine(truncSineX) * sin((5.0+200.0*waveDenity)*x)* 0.1;
    //return truncSine(truncSineX) * sin(100.0*x)* 0.2 * waveDenity;
}

void main()
{
    shiftedX = textureCoordinate.x;
    shiftedY = textureCoordinate.y;
    shiftedX1 = textureCoordinate.x;
    shiftedY1 = textureCoordinate.y;
    shiftedX2 = textureCoordinate.x;
    shiftedY2 = textureCoordinate.y;

    // wave texture
    highp float textureOffset = rdWave(textureCoordinate.y, 0.0);
    shiftedX = textureCoordinate.x + textureOffset;
    shiftedX = fixShiftedValue(shiftedX);

    // wave texture2
    highp float texture2Offset = rdWave(textureCoordinate.y, 0.5);
    shiftedX2 = textureCoordinate.x + texture2Offset;
    shiftedX2 = fixShiftedValue(shiftedX2);

    lowp vec4 textureColor = texture2D(inputImageTexture, vec2(shiftedX, shiftedY));
    lowp vec4 textureColor2 = texture2D(inputImageTexture, vec2(shiftedX2, shiftedY2));

    if ( 1 <= colorMode && colorMode <= 3) {
        lowp vec4 textureColor1 = texture2D(inputImageTexture, vec2(shiftedX1, shiftedY1));
        if (colorMode == 1) {
            gl_FragColor = vec4(textureColor.r, textureColor1.g, textureColor2.b, 1.0);
        }
        else if (colorMode == 2) {
            gl_FragColor = vec4(textureColor.r, textureColor2.g, textureColor1.b, 1.0);
        }
        else if (colorMode == 3) {
            gl_FragColor = vec4(textureColor1.r, textureColor.g, textureColor2.b, 1.0);
        }
    }
    else {
        if (colorMode == 4) {
            gl_FragColor = vec4(textureColor2.r, textureColor.g, textureColor2.b, 1.0);
        }
        else if (colorMode == 5) {
            gl_FragColor = vec4(textureColor.r, textureColor.g, textureColor2.b, 1.0);
        }
        else if (colorMode == 6) {
            gl_FragColor = vec4(textureColor2.r, textureColor.g, textureColor.b, 1.0);
        }
        else {
            gl_FragColor = textureColor;
        }
    }
}
